#include <SPI.h>
#include <WiFly.h>
#include <WiFlyClient.h>

#include <SoftwareSerial.h>
SoftwareSerial mySerial(2,3);

const int batteryVoltagePin = A7;

#include "Credentials.h"
IPAddress server(184,106,153,149);
WiFlyClient client;
uint32_t timeLastUpdated;
uint32_t i;

void setup() {
  
 
  delay(10000);
  Serial.begin(115200);  // nice and fast
  pinMode(8,OUTPUT);
  digitalWrite(8,HIGH);
  mySerial.begin(9600);  // default WiFly baud rate - good enough for this

  WiFly.setUart(&mySerial); // Tell the WiFly library that we are not using the SPIUart
  
  Serial.println("Wifly begin");
  
  WiFly.begin();    // startup the WiFly
  
  Serial.println("Wifly join");
  
  
  // Join the WiFi network
  if (!WiFly.join(ssid, passphrase)) {
    Serial.println("Association failed.");
    while (1) {
    }
  }   
}


void loop() {
 delay(1000); 
 if (millis() - timeLastUpdated > TIMETOUPDATE)
  {  // time for the next update
    timeLastUpdated = millis();
    double thisData = analogRead(batteryVoltagePin) * 0.00322265625 * 6;
    long som = WiFly.getRSSI();
    Serial.println(som);
    Serial.println("connecting...");
    if (client.connect(server,80)) {
      Serial.println("connected");
    // send the HTTP PUT request:
    delay(1000);
    client.print("POST /update HTTP/1.1\n");
    client.print("Host: api.thingspeak.com\n");
    client.print("Connection: close\n");
    client.print("X-THINGSPEAKAPIKEY: ");
    client.print(APIKEY);
    client.print("\n");
    client.print("Content-Type: application/x-www-form-urlencoded\n");
    client.print("Content-Length: ");
    client.print("10");
    client.print("\n\n");
    
    //client.print("Field1=");
    //client.println(thisData);
    
    client.print("field1=");
    client.print(som);
    //client.stop();
    Serial.println("connection good");
    } else {
      Serial.println("connection failed");
    }
    
  }
}

  

